static void Wily4Ascii(Screen& s)
{
GenericAsciiMaker(s,
// Walls
-1,'#', 0x48,3, 0x49,3, 0x4A,3,
        0x50,3, 0x51,3, 0x52,3, // block type 1 (middle piece repeatable)
-1,'#', 0x4B,0, 0x4C,0, 0x4D,0,
        0x53,0, 0x54,0, 0x55,0, // block type 2 (middle piece repeatable)
-1,'#', 0x6F,0, // vertical block
-1,'#', 0x4E,3, // inside floor
-1,'#', 0x64,1, 0x65,1,
        0x6C,1, 0x6D,1, // gutsman decoration
// Decorations
-1,' ', 0x17,2, 0x16,3, // inside bg, inside shadow
// Ladder
-1,'|', 0xC5,0,
// Lift
-1,'*', 0x3E,0, // edge
-1,'-', 0x3C,0, // path
-1,'/', 0x3D,0, // hole
// Spike
-1,'^', 0xAE,0, // black bg
// Various backgrounds
-1,'.', 0x00,0, // black background
-1,'1', 0x00,1, // palette 1 (wily room)
-1,'2', 0x00,2, // palette 2 (wily room)
// Teleport
-1,'_', 0x63,1, 0x69,1, // top
-1,'=', 0x68,1, 0x6A,1, // bottom
// Wily room door
-1,'D', 0x06,0,
// Wily room floor
-1,'W', 0x62,0,
-2);
}

#define Wily4Char  DummyChar

static Level Wily4 =
{
	9, // level number
	"Wily4",

	// screens:
	{
		{
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|  #        ##"   "                "
		"##|  ?        ##"   "                "
		"##|    #     ###"   "                "
		"##|    ?     ?##"   "                "
		"##?       #   ##"   "                "
		"##        ?   ##"   "                "
		"##    ####    ##"   "                "
		"##^^^^####^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Up| LevelBegin},
		{
		"##|#############"   "                "
		"##|#############"   "                "
		"##|???????????##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##??????????####"   "                "
		"##          ####"   "         P      "
		"##      ??  ????"   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"######..##..####"   "       .   .    "
		"##..##..##..####"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "       v        "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"###############."   "                "
		"###############."   "                "
		"########???????."   "                "
		"########       ."   "                "
		"########|#######"   "                "
		"########|?????##"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"..###########|##"   "                "
		"..######?????|##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"....############"   "                "
		"....############"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"..............#."   "                "
		"................"   "                "
		"................"   "                "
		"..#.*------/////"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"^^^^^^^^^^^^^^^^"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"############__##"   "                "
		"..............##"   "                "
		"..............##"   "             O  "
		"...|########==##"   "                "
		"...|........####"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"/---------------"   "                "
		"..............##"   "      U    W    "
		"......#....#..##"   "                "
		"..............##"   "                "
		"^^^^^^^^^^^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 2 // monster graphics index
		,Up| RestartPointA},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 3 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 4 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 5 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##??????????????"   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"__              "   "                "
		"..              "   "                "
		"..              "   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 6 // monster graphics index
		,RestartPointB| Right},
		{
		"################"   "                "
		"################"   "                "
		"??????????????##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "            P SS"
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 7 // monster graphics index
		,Shutter},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"........222222.."   "                "
		"........222222.."   "                "
		"......11111222.."   "                "
		"......11111222.."   "                "
		"......11222222.."   "                "
		"......11222222.."   "                "
		"........2222...."   "                "
		"........2222...."   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		, 7 // monster graphics index
		,End},
	},

	// palette
	{
		15, 32,  0,  2, 
		15, 48, 39, 23, 
		15, 28, 11, 15, 
		15, 32,  0, 60, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 42, 15, 

		15, 32,  0,  2, 
		15,  0, 32, 16, 
		15, 16, 32, 16, 
		15, 32,  0, 60, 
	},

	// after doors palette
	{
/* Not used in Wily stages */
	},

	// actives
	{
		Active( 2, 2, 0x80,0x60, 0xA0,0x80 ),
		Active( 2, 2, 0x80,0x80, 0xA0,0xA0 ),
		Active( 2, 2, 0x80,0xA0, 0xA0,0xC0 ),
	},

	// enemies
	{
		Enemy( 0, 0x10,0xFF, 0x6 ),
		Enemy( 1, 0x10,0xFF, 0x6 ),
		Enemy( 2, 0x10,0xFF, 0x2C ),
	},

	// level gfx (id, count) (max 16); id is block*4+bank
	{
		{ 0x40, 9 }, { 0x92, 4 }, { 0xE2, 1 }, { 0xD8, 1 }, 
		{ 0x5E, 1 }, { 0xC0, 2 }, { 0x43, 4 }, { 0xD8, 2 }, 
		{ 0x63, 8 }, 
	},

	// monster gfx tables (max 11) (5 tiles, 2*3bytepalette)
	{
		{ { 0x6E, 0x92, 0x96, 0x66, 0x72, }, { 48,42,15, 48,42,15,} },
		{ { 0x72, 0xAE, 0xB2, 0x7A, 0x7E, }, { 48,21,15, 48,17,15,} },
		{ { 0x80, 0x84, 0x88, 0x8C, 0x4A, }, { 39,21,15, 48,38,15,} },
		{ { 0x90, 0x94, 0x98, 0x5A, 0x42, }, { 32,21,15, 39,21,15,} },
		{ { 0xA0, 0xA4, 0xA8, 0xAC, 0x46, }, { 32,33,15, 48,38,15,} },
		{ { 0x70, 0x74, 0x78, 0x7C, 0x7B, }, { 39,21,15, 32,0,2,} },
		{ { 0x7A, 0xFE, 0xDE, 0x7A, 0x7E, }, { 39,21,15, 48,17,15,} },
		{ { 0xEA, 0xEE, 0xF2, 0xFB, 0xFF, }, { 48,21,15, 52,21,5,} },
	},

	0x00, // Arrival input

	Wily4Ascii, Wily4Char
};
